<template>
<div>
  <div v-if="!showPlayer" @click="setShowPlayer" class="active-play">
    <div class="d-flex justify-center overlay-payer"><v-icon color="primary">mdi-play-circle-outline</v-icon></div>
    <v-img v-if="current_video.previewThumbnails" :src="current_video.previewThumbnails.src || '/imgs/n-image.png'" class="img-play"></v-img>
  </div>
  <div class="box-player" v-show="showPlayer">
      <div class="infoVideo tempo_atual">{{ time_tempo_atual }}</div>
      <div class="infoVideo total">{{ miliSec(duracao) }}</div>
      <div class="infoVideo full"><v-btn text @click="fullScreen"><v-icon class="white--text">mdi-fullscreen</v-icon></v-btn></div>

      <vue-plyr v-show="current_video.src" ref="plyr">
        <video preload playsinline>
          <source :src="current_video.src"/>
        </video>
      </vue-plyr>

    <input
      v-model="tempo_atual"
      type="range"
      min="0"
      step="0.01"
      max="100"
      @click="nextProgress(tempo_atual)"
      @mouseup="nextProgress(tempo_atual)"
      @keyup="nextProgress(tempo_atual)"
      class="player-control"/>
  </div>
</div>
</template>

<script>
export default {
  name: 'IndexPlayer',
  data () {
    return {
      player: null,
      duracao: '0',
      tempo_atual: '0',
      showPlayer: false,

      time_duracao: 0,
      time_tempo_atual: 0
    }
  },
  props: {
    current_video: Object
  },
  mounted () {
    this.player = this.$refs.plyr.player

    this.player.on('progress', () => {
      this.calculaTempo(this.player.currentTime, this.player.duration)
      this.duracao = this.player.duration
      this.time_tempo_atual = this.miliSec(this.player.currentTime)
    })

    this.player.on('timeupdate', () => {
      if (this.player.playing) {
        this.calculaTempo(this.player.currentTime, this.player.duration)
        this.time_tempo_atual = this.miliSec(this.player.currentTime)
      }
    })

    this.alterButtonPlay()
  },
  created () {
    this.$nuxt.$off('pauseVideo')
    this.$nuxt.$on('pauseVideo', () => {
      this.player.stop()
      this.player.destroy()
    })
  },
  methods: {
    setShowPlayer () {
      this.showPlayer = !this.showPlayer
      this.player.play()
    },
    calculaTempo (current, duracao) {
      const porcentagem = (current * 100) / duracao
      this.tempo_atual = porcentagem
    },
    calculaPorcentagemTempo () {
      this.time_tempo_atual = (this.tempo_atual * this.duracao) / 100
    },
    setPlay () {
      this.player.togglePlay()
    },
    nextProgress (val) {
      const tempo = (val * this.player.duration) / 100
      this.player.currentTime = tempo
    },
    fullScreen () {
      this.player.fullscreen.toggle()
    },
    alterButtonPlay () {
      const button = document.querySelectorAll('.plyr__control--overlaid')[0]
      if (button) {
        button.innerHTML = "<i aria-hidden='true' class='v-icon notranslate mdi mdi-play-circle-outline iconplay'></i>"
      }
    },
    miliSec (millis) {
      const horas = Math.floor(millis / (60 * 60))

      let resto = millis % (60 * 60)
      const minutos = Math.floor(millis / 60)

      resto %= 60
      const segundos = Math.ceil(resto)

      return `${(horas ? horas + ':' : '')}${(minutos < 10 ? '0' + minutos : minutos)}:${(segundos < 10 ? '0' + segundos : segundos)}`
    }
  }
}
</script>

<style>
  .plyr__controls{
    display: none !important;
  }
  .plyr__poster{
    background-size: 100% !important;
  }

  .active-play{
    position: relative;
    cursor: pointer;
  }

  .overlay-payer{
    position: absolute;
    width: 100%;
    height: 100%;
    z-index: 4;
  }

  .img-play{
    height: 500px;
  }

  .box-player{
    position: relative;
  }

  .plyr__control--overlaid{
    background: transparent !important;
  }

  .iconplay{
    color: #EF5350;
  }

  .player-control{
    position: absolute;
    bottom: -10px;
    width: 100%;
  }

  .player-control::-moz-range-track, .player-control::-webkit-slider-runnable-track {
    background: transparent !important;
    background-color: transparent;
  }

  .player-control::-webkit-slider-thumb, .player-control::-moz-range-thumb{
    border:none;
    background-color: #EF5350;
    width: 10px;
    height: 10px;
  }

  .setplay{
    background-color: #069;
  }

  .infoVideo {
    position:absolute;
    z-index: 4;
  }

  .tempo_atual{
    bottom: 30px;
    left: 30px;
    color: #FFF;
  }

  .total{
    bottom: 30px;
    right: 30px;
    color: #FFF;
  }

  .full{
    top: 30px;
    right: 30px;
  }

  @media (min-width: 600px) {
    .box-player{
      width: 70%;
      margin: 0 auto;
    }
  }
  @media (max-width: 600px) {
    .img-play{
      height: 300px;
    }
  }
</style>
